// affichage des puissance max de sortie des differents modes
// d'un DAC.
// NRZ, NRZT et RTZ sont obtenus a partir de la meme fonction en faisant 
// varier K, le mode RF est obtenue avec une fonction specifiques
// on suppose que les fronts sont assez raides par rapport à la période 
// pour que la formule en sinc(X) s'applique.
// les calculs se font en frequence normalisés (Fout/Fsample)
// l'affichage se fait en frequence réelle
// 1. recuperation des parametres d'éxecution:
// Mode IUCM: 0 ==> No, 1 ==> Yes
// Frequence d'horloge 
// bande passante
// Nb de zone de Nyquist
// Min Reshaping pulse width pour NRTZ et RF
// Max Reshaping pulse width pour NRTZ et RF
// Reshaping pulse width sweep step.
// Revision F.B 22/03/2013: sortie des donneées en mode csv pour inclusion dans excel
// reste a gerer correctement le nom de ces fichiers..
labels=["Mode IUCM [1 2 4]:";"Sampling Frequency [GHz]:";"Output bandwidth [GHz]:";...
"Number of Nyquist zones plotted:";"Min Reshaping pulse width[ps]";...
"Max Reshaping pulse width[ps]";"Reshaping pulse width step [ps]"];...
[ok,Iucm,Fsamp,BWGHz,nbNZ,minrpw,maxrpw,steprpw]=getvalue("Max Pout Vs Fout in 4 modes",...
labels,list("vec",1,"vec",1,"vec",1,"vec",1,"vec",1,"vec",1,"vec",1),...
["1";"3";"7";"8";"75";"75";"1"])
if Iucm==1 then
    Iucm_fact=1;
    Iucm_text="+IUCM1";
    // definition des fonction de base RTZ_NRZmode et RFmode:
    function y=RTZ_NRZmode(x,k)
        y=20.*log10(%eps+abs(k.*sinc(%pi.*x.*k)./0.893));
    endfunction
    function y=RFmode(x,k)
        y=20.*log10(%eps+abs(k.*sinc(%pi.*x.*k./2).*sin(%pi.*x.*k./2)./0.893));
    endfunction
end
if Iucm==2 then
    Iucm_fact=1/2;
    Iucm_text="+IUCM2";
    // definition des fonction de base RTZ_NRZmode et RFmode:
    function y=RTZ_NRZmode(x,k)
        y=20.*log10(%eps+abs(k.*sinc(%pi.*x.*k).*cos(%pi.*x)./0.893));
    endfunction
    function y=RFmode(x,k)
        y=20.*log10(%eps+abs(k.*sinc(%pi.*x.*k./2).*sin(%pi.*x.*k./2).*cos(%pi.*x)./0.893));
    endfunction
end
if  Iucm==4 then
    Iucm_fact=1/4;
    Iucm_text="+IUCM4";
    // definition des fonction de base RTZ_NRZmode et RFmode:
    function y=RTZ_NRZmode(x,k)
        y=20.*log10(%eps+abs(k.*sinc(%pi.*x.*k).*cos(%pi.*x.*2)./0.893));
    endfunction
    function y=RFmode(x,k)
        y=20.*log10(%eps+abs(k.*sinc(%pi.*x.*k./2).*sin(%pi.*x.*k./2).*cos(%pi.*x.*2)./0.893));
    endfunction
end
fnorm=linspace(0,Iucm_fact*nbNZ/2,2000);
fnorm1=linspace(0,Iucm_fact*nbNZ/2,200);

    // borne des zones de nyquist:
    NZedge=linspace(0,Iucm_fact*nbNZ*Fsamp/2,nbNZ+1);
fGHz=Fsamp*fnorm;
fGHz1=Fsamp*fnorm1;
// ecrit le fichier csv des frequence pour import excel
//file_freq_csv="/userna10/bore/trans/Scilab/fGHz.csv";
//write_csv(fGHz.',file_freq_csv);
// definition des fonction de base atten (1st order LPF)
function y=atten(x,BW)
    y=-20*log10(sqrt(1+((x./BW).*(x./BW))))
endfunction
scf(1);clf(1,"reset");
fig1=gcf();fig1.figure_size=[1280,980];fig1.figure_position=[0,0];
//fig1.fontsize=4;
//drawlater();
// affichage mode NRZ: k=1
k=1;Mode_text="NRZ";
subplot(221);plot2d3(NZedge,NZedge-NZedge-80,25);
a=gca();poly1=a.children(1).children(1);poly1.thickness=3;poly1.line_style=3;
plot2d(fGHz,RTZ_NRZmode(fnorm,k),6);
a=gca();poly1=a.children(1).children(1);poly1.thickness=3;poly1.line_style=8;

NRZdata=RTZ_NRZmode(fnorm,k)+atten(fGHz,BWGHz);
// plot2d(fGHz,RTZ_NRZmode(fnorm,k)+atten(fGHz,BWGHz),3);
plot2d(fGHz,NRZdata,3);
//file_csv1="/userna10/bore/trans/Scilab/NRZ.csv";
//write_csv(NRZdata.',file_csv1);
a=gca();a.font_style=9;poly1=a.children(1).children(1);poly1.thickness=3;
mytitle=msprintf('%s%s%s%1.3f%s',Mode_text,Iucm_text," mode: Max Pout  vs Fout @ ",...
Fsamp,"Gsps");
title(mytitle,'fontsize',4,'color','blue');
xlabel("Fout  [GHz]","fontsize",4);ylabel("Pout [ dBm]","fontsize",4);
set(gca(),'grid',[-1 1]);set(gca(),'font_size',4);
square(0,-80,Iucm_fact*Fsamp*nbNZ/2,5);
legends(['NRZ mode ideal' msprintf('%s%1.1f%s',"NRZ mode BW = ",BWGHz,"GHz")],...
[6,3],font_size=4,opt=3);

// affichage mode RTZ: k=0.5
k=0.5;Mode_text="RTZ"
subplot(222);plot2d3(NZedge,NZedge-NZedge-80,25);
a=gca();poly1=a.children(1).children(1);poly1.thickness=3;poly1.line_style=3;
plot2d(fGHz,RTZ_NRZmode(fnorm,k),6);
a=gca();poly1=a.children(1).children(1);poly1.thickness=3;poly1.line_style=8;
RTZdata=RTZ_NRZmode(fnorm,k)+atten(fGHz,BWGHz);
// plot2d(fGHz,RTZ_NRZmode(fnorm,k)+atten(fGHz,BWGHz),3);
plot2d(fGHz,RTZdata,3);
//file_csv1="/userna10/bore/trans/Scilab/RTZ.csv";
//write_csv(RTZdata.',file_csv1)
a=gca();a.font_style=9;poly1=a.children(1).children(1);poly1.thickness=3;
mytitle=msprintf('%s%s%s%1.3f%s',Mode_text,Iucm_text," mode: Max Pout vs Fout @ ",...
Fsamp,"Gsps");
title(mytitle,'fontsize',5,'color','blue');
xlabel("Fout  [GHz]","fontsize",4);ylabel("Pout  [dBm]","fontsize",4);
set(gca(),'grid',[-1 1]);set(gca(),'font_size',4);
square(0,-80,Iucm_fact*Fsamp*nbNZ/2,5);
legends(['RTZ mode ideal' msprintf('%s%1.1f%s',"RTZ mode BW = ",BWGHz,"GHz")],...
[6,3],font_size=4,opt=3);

// affichage mode NRTZ avec balayage reshaping pulse width:
subplot(223);plot2d3(NZedge,NZedge-NZedge-80,25);
a=gca();poly1=a.children(1).children(1);poly1.thickness=3;poly1.line_style=3;
//k=K1;
Mode_text="NRTZ";
i=0;
for pw1=minrpw:steprpw:maxrpw
    i=i+1;
    // calcul de K1 à partir de pw1 Fsamp:  K1=((1000/Fsamp)-pw1)/(1000/Fsamp);
    K1=((1000/Fsamp)-pw1)/(1000/Fsamp);
    k=K1;
    plot2d(fGHz,RTZ_NRZmode(fnorm,k),6);
    if i==1 then NRTZdata=RTZ_NRZmode(fnorm,k)+atten(fGHz,BWGHz);
//        file_csv1="/userna10/bore/trans/Scilab/NRTZ.csv"
//        file_csv2="/userna10/bore/trans/Scilab/fGHz.csv"
        // transposition des matrice avnat la sortie en csv: utilisation de l'operateur .'
//        write_csv(NRTZdata.',file_csv1)
//        write_csv(fGHz.',file_csv2)
    end
    a=gca();poly1=a.children(1).children(1);poly1.thickness=3;poly1.line_style=8;
//    plot2d(fGHz,RTZ_NRZmode(fnorm,k)+atten(fGHz,BWGHz),i);
    plot2d(fGHz,RTZ_NRZmode(fnorm,k)+atten(fGHz,BWGHz),3);
    a=gca();a.font_style=9;poly1=a.children(1).children(1);poly1.thickness=3;
end
if minrpw==maxrpw then
    mytitle=msprintf('%s%s%s%1.0f%s%1.3f%s',Mode_text,Iucm_text," rpw ",minrpw,...
"ps: Max Pout vs Fout @ ",Fsamp,"Gsps");
title(mytitle,'fontsize',4,'color','blue');
else
    mytitle=msprintf('%s%s%s%1.0f%s%1.0f%s%1.1f%s',Mode_text,Iucm_text," mode rpw sweep from ",minrpw,...
"ps to ",maxrpw,"ps :\n Max Pout vs Fout @ ",Fsamp,"Gsps");
title(mytitle,'fontsize',4,'color','blue');
end
xlabel("Fout  [GHz]","fontsize",4);ylabel("Pout  [dBm]","fontsize",4);
set(gca(),'grid',[-1 1]);set(gca(),'font_size',4);
square(0,-80,Iucm_fact*Fsamp*nbNZ/2,5);
legends(['NRTZ mode Ideal' msprintf('%s%1.1f%s',"NRTZ mode BW = ",BWGHz,"GHz")],[6,3],...
font_size=4,opt=3);
// affichage mode RF: k=K2
//k=K2;
Mode_text="RF";
i=0;
subplot(224);plot2d3(NZedge,NZedge-NZedge-80,25);
a=gca();poly1=a.children(1).children(1);poly1.thickness=3;poly1.line_style=3;
for pw2=minrpw:steprpw:maxrpw
    i=i+1;
        if i==1 then RFdata=RFmode(fnorm,k)+atten(fGHz,BWGHz);
//        file_csv1="/userna10/bore/trans/Scilab/RF.csv"
//        write_csv(RFdata.',file_csv1)
    end
    K2=((1000/Fsamp)-pw2)/(1000/Fsamp);
    k=K2;
    plot2d(fGHz,RFmode(fnorm,k),6);
    a=gca();poly1=a.children(1).children(1);poly1.thickness=3;poly1.line_style=8;
//    plot2d(fGHz,RFmode(fnorm,k)+atten(fGHz,BWGHz),i);
    plot2d(fGHz,RFmode(fnorm,k)+atten(fGHz,BWGHz),3);
    a=gca();a.font_style=9;poly1=a.children(1).children(1);poly1.thickness=3;
end
if minrpw==maxrpw then
    mytitle=msprintf('%s%s%s%1.0f%s%1.3f%s',Mode_text,Iucm_text," rpw ",minrpw,...
"ps: Max Pout vs Fout @ ",Fsamp,"Gsps");
title(mytitle,'fontsize',5,'color','blue');
else
    mytitle=msprintf('%s%s%s%1.0f%s%1.0f%s%1.3f%s',Mode_text,Iucm_text," mode rpw sweep from ",minrpw,...
"ps to ",maxrpw,"ps:\nMax Pout vs Fout @ ",Fsamp,"Gsps");
title(mytitle,'fontsize',4,'color','blue');
end
xlabel("Fout  [GHz]","fontsize",4);ylabel("Pout  [dBm]","fontsize",4);
set(gca(),'grid',[-1 1]);set(gca(),'font_size',4);
square(0,-80,Iucm_fact*Fsamp*nbNZ/2,5);
legends(['RF mode ideal' msprintf('%s%1.1f%s',"RF mode BW = ",BWGHz,"GHz")],...
[6,3],font_size=4,opt=3);
// remet au propre les line de legendes:
for i=0:3
poly1=fig1.children(1+2*i).children(1).children(4);poly1.thickness=2;poly1.line_style=8;
poly1=fig1.children(1+2*i).children(1).children(2);poly1.thickness=2;
end
//drawnow()
// print to a pdf file.
//chdir("../trans/Scilab")
//filename=msprintf('%s%1.0f%s%1.0f%s%1.0f%s%1.0f%s%1.0f%s',"4modesGrpw",minrpw,"_",maxrpw,"BW",BWGHz,"SR",Fsamp,"NZ",nbNZ,Iucm_text);
//xs2pdf(gcf(),filename);
//chdir("../../SciLab");

// This is the end...
